//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script = {
  name: "vue-morph-table",
  props: {
    alias: String,
    items: Array,
    fields: Array,
    actions: {
      type: Array,
      default: () => []
    },
    addTableClasses: [String, Array, Object],
    responsive: {
      type: Boolean,
      default: true
    },
    size: String,
    dark: Boolean,
    pagination: Boolean,
    striped: Boolean,
    fixed: Boolean,
    hover: Boolean,
    border: Boolean,
    outlined: Boolean,
    bulkAction: Boolean,
    header: {
      type: Boolean,
      default: true
    },
    sorter: [Object, Boolean],
    sorterValue: {
      type: Object,
      default: () => {
        return {};
      }
    },
    numOfRows: Array,
    itemsLength: Number,
    loading: Boolean
  },

  data() {
    return {
      show: false,
      overlayStyle: {
        width: "0%",
        opacity: 0
      },
      sorterState: {
        column: null,
        asc: true
      },
      checkAll: false,
      lastFields: -1,
      currentPage: 1,
      noRows: 10
    };
  },

  computed: {
    totalPage() {
      return Math.ceil(this.$props.itemsLength / this.noRows);
    },

    allFields: {
      get: function () {
        let showFieldsLength = 0;
        this.$props.fields.forEach(f => {
          if (this.alias) localStorage.setItem(`${f.key}.${this.alias}.morph`, f.check);
          if (f.check) showFieldsLength++;
        });

        if (showFieldsLength === this.$props.fields.length) {
          this.checkAll = true;
        } else {
          this.checkAll = false;
        }

        return this.$props.fields;
      },
      set: function (newVal) {
        this.$emit("update:fields", newVal);
      }
    },

    filterFields() {
      let ret = [];
      let idx = -1;
      this.allFields.forEach((f, index) => {
        if (f.check) {
          ret.push(f);
          idx = index;
        }
      });
      this.lastFields = ret.length === 1 ? idx : -1;
      return ret !== [] ? ret : null;
    },

    tableClasses() {
      return ["table", this.addTableClasses, {
        "table-striped": this.striped,
        "table-hover": this.hover,
        "table-bordered": this.border,
        border: this.outlined
      }];
    },

    itemsDataColumns() {
      return this.rawColumnNames.filter(name => {
        return this.generatedColumnNames.includes(name);
      });
    },

    generatedColumnNames() {
      return Object.keys(this.items[0] || {}).filter(el => el.charAt(0) !== "_");
    },

    columnNames() {
      if (this.filterFields) {
        return this.filterFields.map(f => {
          return f.label !== undefined ? f.label : this.pretifyName(f.key || f);
        });
      }

      return this.rawColumnNames.map(el => this.pretifyName(el));
    },

    rawColumnNames() {
      if (this.filterFields) {
        return this.filterFields.map(el => el.key || el);
      }

      return this.generatedColumnNames;
    },

    sidebarWidth() {
      const value = this.show ? "250px" : 0;
      return {
        width: value
      };
    },

    checkAllBulk: {
      get: function () {
        let cnt = 0;
        this.items.forEach(i => {
          if (i.check_bulk === true) cnt++;
        });

        if (cnt === this.items.length) {
          return true;
        }
      },
      set: function (newVal) {
        if (newVal === true) {
          let ret = [...this.items];
          ret.map(i => {
            i.check_bulk = true;
          });
          this.$emit("update:items", ret);
        }
      }
    }
  },
  watch: {
    currentPage(val) {
      if (val < 1) val = 1;else if (val > this.totalPage) val = totalPage;
      this.$emit("changeCurrentPage", val);
    },

    sorterValue: {
      immediate: true,

      handler(val) {
        const asc = val.asc !== false;
        this.sorterState = Object.assign({}, {
          asc,
          column: val.column
        });
      }

    },

    checkAll(val) {
      if (val === true) {
        this.allFields.forEach(f => {
          f.check = true;
        });
      }
    }

  },
  methods: {
    range(currentPage) {
      if (currentPage === 1 || currentPage === 2 || currentPage === 3) {
        if (this.totalPage < 5) return this.totalPage;
        return 5;
      } else if (currentPage === this.totalPage || currentPage === this.totalPage - 1 || currentPage === this.totalPage - 2) {
        if (this.totalPage < 5) return this.totalPage;
        return [this.totalPage - 4, this.totalPage - 3, this.totalPage - 2, this.totalPage - 1, this.totalPage];
      } else {
        return [currentPage - 2, currentPage - 1, currentPage, currentPage + 1, currentPage + 2];
      }
    },

    changePage(page) {
      if (page > this.totalPage) page = this.totalPage;else if (page < 1) page = 1;
      this.currentPage = page;
    },

    changeSort(column, index) {
      if (!this.isSortable(index)) {
        return;
      }

      const state = this.sorterState;
      const columnRepeated = state.column === column;
      state.column = column;
      state.asc = !(columnRepeated && state.asc);
      this.$emit("update:sorter-value", this.sorterState);
      this.$emit("sort", this.sorterState);
    },

    getIconState(index) {
      const direction = this.sorterState.asc ? "asc" : "desc";
      return this.rawColumnNames[index] === this.sorterState.column ? direction : 0;
    },

    iconClasses(index) {
      const state = this.getIconState(index);
      return ["arrow", {
        transparent: !state,
        "rotate-icon": state === "desc"
      }];
    },

    pretifyName: function (name) {
      return name.replace(/[-_.]/g, " ").replace(/ +/g, " ").replace(/([a-z0-9])([A-Z])/g, "$1 $2").split(" ").map(word => word.charAt(0).toUpperCase() + word.slice(1)).join(" ");
    },

    isSortable(index) {
      return this.sorter && (!this.fields || this.fields[index].sorter !== false) && this.itemsDataColumns.includes(this.rawColumnNames[index]);
    },

    openSidebar() {
      this.show = true;
      this.overlayStyle.width = "100%";
      this.overlayStyle.opacity = 0.8;
    },

    closeSidebar() {
      this.show = false;
      this.overlayStyle.width = "0%";
      this.overlayStyle.opacity = 0;
    },

    changeCheck(index) {
      this.$emit("update:fields", [...this.fields.slice(0, index), { ...this.fields[index],
        check: !this.fields[index].check
      }, ...this.fields.slice(index + 1)]);
    },

    changeCheckBulk(index) {
      this.$emit("update:items", [...this.items.slice(0, index), { ...this.items[index],
        check_bulk: !this.items[index].check_bulk
      }, ...this.items.slice(index + 1)]);
    },

    changeCheckAll() {
      this.checkAll = true;
    },

    changeCheckAllBulk() {
      this.checkAllBulk = true;
    },

    changeNumOfRows(e) {
      this.noRows = e.target.value;
      this.$emit("changeNumOfRows", e.target.value);
    },

    clickRow(data) {
      this.$emit("clickRow", data);
    }

  }
};

function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}

const isOldIE = typeof navigator !== 'undefined' &&
    /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());
function createInjector(context) {
    return (id, style) => addStyle(id, style);
}
let HEAD;
const styles = {};
function addStyle(id, css) {
    const group = isOldIE ? css.media || 'default' : id;
    const style = styles[group] || (styles[group] = { ids: new Set(), styles: [] });
    if (!style.ids.has(id)) {
        style.ids.add(id);
        let code = css.source;
        if (css.map) {
            // https://developer.chrome.com/devtools/docs/javascript-debugging
            // this makes source maps inside style tags work properly in Chrome
            code += '\n/*# sourceURL=' + css.map.sources[0] + ' */';
            // http://stackoverflow.com/a/26603875
            code +=
                '\n/*# sourceMappingURL=data:application/json;base64,' +
                    btoa(unescape(encodeURIComponent(JSON.stringify(css.map)))) +
                    ' */';
        }
        if (!style.element) {
            style.element = document.createElement('style');
            style.element.type = 'text/css';
            if (css.media)
                style.element.setAttribute('media', css.media);
            if (HEAD === undefined) {
                HEAD = document.head || document.getElementsByTagName('head')[0];
            }
            HEAD.appendChild(style.element);
        }
        if ('styleSheet' in style.element) {
            style.styles.push(code);
            style.element.styleSheet.cssText = style.styles
                .filter(Boolean)
                .join('\n');
        }
        else {
            const index = style.ids.size - 1;
            const textNode = document.createTextNode(code);
            const nodes = style.element.childNodes;
            if (nodes[index])
                style.element.removeChild(nodes[index]);
            if (nodes.length)
                style.element.insertBefore(textNode, nodes[index]);
            else
                style.element.appendChild(textNode);
        }
    }
}

/* script */
const __vue_script__ = script;
/* template */

var __vue_render__ = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "wrapper"
  }, [_c('div', {
    staticClass: "overlay",
    style: _vm.overlayStyle,
    on: {
      "click": _vm.closeSidebar
    }
  }), _vm._v(" "), _c('div', {
    staticClass: "sidebar",
    style: _vm.sidebarWidth
  }, [_c('a', {
    staticClass: "close-btn",
    attrs: {
      "href": "javascript:void(0)"
    },
    on: {
      "click": _vm.closeSidebar
    }
  }, [_vm._v("×")]), _vm._v(" "), _c('div', {
    staticClass: "content"
  }, [_c('div', {
    staticClass: "form-check-default box-checkbox"
  }, [_c('input', {
    staticClass: "form-checkbox-input",
    attrs: {
      "type": "checkbox",
      "value": "all",
      "id": "flexCheckDefault",
      "disabled": _vm.checkAll
    },
    domProps: {
      "checked": _vm.checkAll
    },
    on: {
      "change": _vm.changeCheckAll
    }
  }), _vm._v(" "), _c('label', {
    staticClass: "form-checkbox-label",
    attrs: {
      "for": "flexCheckDefault"
    }
  }, [_vm._v(" All")])]), _vm._v(" "), _vm._l(_vm.allFields, function (field, index) {
    return [_c('div', {
      key: index,
      staticClass: "form-check-default box-checkbox"
    }, [_c('input', {
      staticClass: "form-checkbox-input",
      attrs: {
        "type": "checkbox",
        "id": "flexCheckDefault-" + index,
        "disabled": _vm.lastFields === index
      },
      domProps: {
        "value": field.value,
        "checked": field.check
      },
      on: {
        "change": function ($event) {
          return _vm.changeCheck(index);
        }
      }
    }), _vm._v(" "), _c('label', {
      staticClass: "form-checkbox-label",
      attrs: {
        "for": "flexCheckDefault-" + index
      }
    }, [_vm._v("\n              " + _vm._s(field.label) + "\n            ")])])];
  })], 2)]), _vm._v(" "), _c('div', {
    staticClass: "utils"
  }, [_c('div', {
    staticClass: "separator"
  }), _vm._v(" "), _vm.numOfRows ? _c('div', {
    staticClass: "select-num-of-rows"
  }, [_c('label', {
    attrs: {
      "for": "num-of-rows"
    }
  }, [_vm._v("Number of rows:")]), _vm._v(" "), _c('select', {
    attrs: {
      "name": "num-of-rows",
      "id": "num-of-rows"
    },
    on: {
      "change": _vm.changeNumOfRows
    }
  }, _vm._l(_vm.numOfRows, function (num) {
    return _c('option', {
      key: num,
      domProps: {
        "value": num
      }
    }, [_vm._v("\n            " + _vm._s(num) + "\n          ")]);
  }), 0)]) : _vm._e(), _vm._v(" "), _c('button', {
    staticClass: "btn",
    on: {
      "click": _vm.openSidebar
    }
  }, [_c('svg', {
    attrs: {
      "height": "10pt",
      "viewBox": "0 -53 384 384",
      "width": "10pt",
      "xmlns": "http://www.w3.org/2000/svg"
    }
  }, [_c('path', {
    attrs: {
      "d": "m368 154.667969h-352c-8.832031 0-16-7.167969-16-16s7.167969-16 16-16h352c8.832031 0 16 7.167969 16 16s-7.167969 16-16 16zm0 0"
    }
  }), _vm._v(" "), _c('path', {
    attrs: {
      "d": "m368 32h-352c-8.832031 0-16-7.167969-16-16s7.167969-16 16-16h352c8.832031 0 16 7.167969 16 16s-7.167969 16-16 16zm0 0"
    }
  }), _vm._v(" "), _c('path', {
    attrs: {
      "d": "m368 277.332031h-352c-8.832031 0-16-7.167969-16-16s7.167969-16 16-16h352c8.832031 0 16 7.167969 16 16s-7.167969 16-16 16zm0 0"
    }
  })])])]), _vm._v(" "), _vm.loading ? _vm._t("loading", [_vm._m(0)]) : _vm._e(), _vm._v(" "), _c('div', {
    class: "position-relative " + (_vm.responsive ? 'tbl-responsive' : '')
  }, [!_vm.loading ? _c('table', {
    class: _vm.tableClasses
  }, [_c('thead', [_vm.header ? _c('tr', [_vm.bulkAction ? _c('th', {
    staticClass: "bulk-action"
  }, [_c('input', {
    attrs: {
      "type": "checkbox",
      "name": "check-all-bulk-actions",
      "id": "check-all-bulk-actions",
      "disabled": _vm.checkAllBulk
    },
    domProps: {
      "checked": _vm.checkAllBulk
    },
    on: {
      "change": function ($event) {
        $event.stopPropagation();
        return _vm.changeCheckAllBulk($event);
      }
    }
  })]) : _vm._e(), _vm._v(" "), _vm._l(_vm.columnNames, function (columnName, index) {
    return [_c('th', {
      key: index,
      on: {
        "click": function ($event) {
          return _vm.changeSort(_vm.rawColumnNames[index], index);
        }
      }
    }, [_vm._t(_vm.rawColumnNames[index] + "-header", [_c('span', [_vm._v(_vm._s(columnName))])]), _vm._v(" "), _vm.isSortable(index) ? _vm._t("sorting-icon", [_c('div', {
      class: _vm.iconClasses(index)
    }, [_c('svg', {
      staticStyle: {
        "enable-background": "new 0 0 512 512"
      },
      attrs: {
        "width": "1rem",
        "version": "1.1",
        "id": "Capa_1",
        "xmlns": "http://www.w3.org/2000/svg",
        "xmlns:xlink": "http://www.w3.org/1999/xlink",
        "x": "0px",
        "y": "0px",
        "viewBox": "0 0 512 512",
        "xml:space": "preserve"
      }
    }, [_c('path', {
      staticStyle: {
        "fill": "#4caf50"
      },
      attrs: {
        "d": "M263.432,3.136c-4.16-4.171-10.914-4.179-15.085-0.019c-0.006,0.006-0.013,0.013-0.019,0.019\n\tl-192,192c-4.093,4.237-3.975,10.99,0.262,15.083c4.134,3.992,10.687,3.992,14.82,0L245.213,36.416v464.917\n\tc0,5.891,4.776,10.667,10.667,10.667c5.891,0,10.667-4.776,10.667-10.667V36.416l173.781,173.781\n\tc4.093,4.237,10.845,4.355,15.083,0.262c4.237-4.093,4.354-10.845,0.262-15.083c-0.086-0.089-0.173-0.176-0.262-0.262L263.432,3.136\n\tz"
      }
    }), _vm._v(" "), _c('path', {
      attrs: {
        "d": "M447.88,213.333c-2.831,0.005-5.548-1.115-7.552-3.115L255.88,25.749L71.432,210.219c-4.237,4.093-10.99,3.975-15.083-0.262\n\tc-3.992-4.134-3.992-10.687,0-14.82l192-192c4.165-4.164,10.917-4.164,15.083,0l192,192c4.159,4.172,4.149,10.926-0.024,15.085\n\tC453.409,212.214,450.702,213.333,447.88,213.333z"
      }
    }), _vm._v(" "), _c('path', {
      attrs: {
        "d": "M255.88,512c-5.891,0-10.667-4.776-10.667-10.667V10.667C245.213,4.776,249.989,0,255.88,0\n\tc5.891,0,10.667,4.776,10.667,10.667v490.667C266.546,507.224,261.771,512,255.88,512z"
      }
    }), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g')])])], {
      "state": _vm.getIconState(index)
    }) : _vm._e()], 2)];
  }), _vm._v(" "), _vm._l(_vm.actions, function (action, index) {
    return [_c('th', {
      key: "action_" + index
    }, [_vm._t(action['key'] + "-header")], 2)];
  })], 2) : _vm._e()]), _vm._v(" "), _c('tbody', [_vm._l(_vm.items, function (item, itemIndex) {
    return [_c('tr', {
      key: itemIndex,
      on: {
        "click": function ($event) {
          return _vm.clickRow(item);
        }
      }
    }, [_vm.bulkAction ? _c('td', {
      staticClass: "bulk-action"
    }, [_c('input', {
      attrs: {
        "type": "checkbox",
        "name": "check-" + item.key + "-bulk-action",
        "id": "check-" + item.key + "-bulk-action"
      },
      domProps: {
        "checked": item.check_bulk
      },
      on: {
        "change": function ($event) {
          $event.stopPropagation();
          return _vm.changeCheckBulk(itemIndex);
        }
      }
    })]) : _vm._e(), _vm._v(" "), _vm._l(_vm.rawColumnNames, function (colName, colNameIndex) {
      return [_vm.$scopedSlots[colName] ? _vm._t(colName, null, {
        "item": item,
        "index": itemIndex
      }) : _c('td', {
        key: colNameIndex
      }, [_vm._v(_vm._s(String(item[colName])))])];
    }), _vm._v(" "), _vm._l(_vm.actions, function (actionInRow, indexActionInRow) {
      return [_vm.$scopedSlots[actionInRow['key']] ? _vm._t(actionInRow['key'], null, {
        "item": item,
        "index": itemIndex
      }) : _c('td', {
        key: "action_" + indexActionInRow
      }, [_vm._v("\n                  " + _vm._s(actionInRow["name"]) + "\n                ")])];
    })], 2)];
  })], 2)]) : _vm._e(), _vm._v(" "), !_vm.loading && _vm.pagination && _vm.totalPage !== 1 ? _c('div', {
    staticClass: "table-footer"
  }, [_c('div', {
    staticClass: "separator"
  }), _vm._v(" "), _c('div', {
    staticClass: "pagination pagination--position"
  }, [_c('a', {
    attrs: {
      "href": "#first"
    },
    on: {
      "click": function ($event) {
        return _vm.changePage(1);
      }
    }
  }, [_vm._v("«")]), _vm._v(" "), _c('a', {
    attrs: {
      "href": "#previous"
    },
    on: {
      "click": function ($event) {
        return _vm.changePage(_vm.currentPage - 1);
      }
    }
  }, [_vm._v("‹")]), _vm._v(" "), _vm._l(_vm.range(_vm.currentPage), function (page) {
    return _c('a', {
      key: page,
      class: {
        'page-active': page === _vm.currentPage
      },
      attrs: {
        "href": "javascript:void(0)"
      },
      on: {
        "click": function ($event) {
          return _vm.changePage(page);
        }
      }
    }, [_vm._v(_vm._s(page))]);
  }), _vm._v(" "), _c('a', {
    attrs: {
      "href": "#next"
    },
    on: {
      "click": function ($event) {
        return _vm.changePage(_vm.currentPage + 1);
      }
    }
  }, [_vm._v("›")]), _vm._v(" "), _c('a', {
    attrs: {
      "href": "#last"
    },
    on: {
      "click": function ($event) {
        return _vm.changePage(_vm.totalPage);
      }
    }
  }, [_vm._v("»")])], 2), _vm._v(" "), _c('div', {
    staticClass: "separator"
  })]) : _vm._e()])], 2);
};

var __vue_staticRenderFns__ = [function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "loading"
  }, [_c('div', {
    staticClass: "loader"
  })]);
}];
/* style */

const __vue_inject_styles__ = function (inject) {
  if (!inject) return;
  inject("data-v-642082a0_0", {
    source: ".separator[data-v-642082a0]{flex:1}.table-footer[data-v-642082a0]{display:flex;align-items:center;justify-content:center}.table-footer .pagination--position[data-v-642082a0]{margin:1.5rem auto 1.5rem 0}.table-footer .pagination a[data-v-642082a0]{color:#000;float:left;padding:8px 16px;text-decoration:none;transition:background-color .3s}.table-footer .pagination a.page-active[data-v-642082a0]{background-color:#2b3856;color:#fff;border-radius:5px}.rotate-icon[data-v-642082a0]{transform:rotate(180deg);top:-.3rem}div.arrow[data-v-642082a0]{display:inline-block;position:relative;margin-left:.1rem;vertical-align:middle;font-size:27px}div.arrow img.sort-icon[data-v-642082a0]{padding:0;width:1rem}.position-relative[data-v-642082a0]{position:relative}div.wrapper[data-v-642082a0]{font-family:Arial,Helvetica,sans-serif}div.wrapper div.overlay[data-v-642082a0]{position:fixed;height:100vh;z-index:3000;left:0;top:0;background-color:#111}div.wrapper div.sidebar[data-v-642082a0]{position:fixed;height:100%;z-index:3000;top:0;right:0;background-color:#fff;overflow-x:hidden;transition:.5s;padding-top:60px}div.wrapper div.sidebar a[data-v-642082a0]{padding:8px 8px 8px 32px;text-decoration:none;font-size:25px;color:#616161;display:block;transition:.3s}div.wrapper div.sidebar a[data-v-642082a0]:hover{color:#a1a1a1;cursor:pointer}div.wrapper div.sidebar .close-btn[data-v-642082a0]{position:absolute;top:0;right:10px;font-size:24px;margin-left:10px}div.wrapper div.sidebar .content[data-v-642082a0]{margin:0 0 0 2rem}.table[data-v-642082a0]{border-collapse:collapse;width:100%}.table td[data-v-642082a0],.table th[data-v-642082a0]{border-top:1px solid #ddd;border-bottom:1px solid #ddd;padding:8px;white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.table.table-bordered td[data-v-642082a0],.table.table-bordered th[data-v-642082a0]{border:1px solid #ddd;padding:8px}.table th[data-v-642082a0]{padding-top:12px;padding-bottom:12px;text-align:left;background-color:#fff}.table.table-striped tr[data-v-642082a0]:nth-child(odd){background-color:#f2f2f2}.table.table-hover tr[data-v-642082a0]:hover{background-color:#ddd}.btn[data-v-642082a0]{border:none;padding:15px 32px;text-align:center;text-decoration:none;display:inline-block;font-size:16px;background-color:#fff}.utils[data-v-642082a0]{display:flex;align-items:center}.utils .select-num-of-rows[data-v-642082a0]{margin-right:10px}.utils .select-num-of-rows label[data-v-642082a0]{margin-right:10px}.utils .select-num-of-rows select#num-of-rows[data-v-642082a0]{padding:.5rem 1rem;background-color:#fff;border:1px solid #ddd;color:#333;border-radius:5px}.utils .select-num-of-rows select#num-of-rows[data-v-642082a0]:hover{border-color:#999;background-color:#eee}.utils .select-num-of-rows select#num-of-rows option[data-v-642082a0]{padding:.5rem 1rem;background-color:#fff}.loading[data-v-642082a0]{position:absolute;display:flex;align-items:center;justify-content:center;height:25rem;width:100%;background-color:#eee}.loading .loader[data-v-642082a0]{border-radius:50%;border:8px solid #eee;border-top:8px solid #3498db;border-bottom:8px solid #3498db;width:60px;height:60px;-webkit-animation:spin-data-v-642082a0 2s linear infinite;animation:spin-data-v-642082a0 2s linear infinite}@-webkit-keyframes spin-data-v-642082a0{0%{-webkit-transform:rotate(0)}100%{-webkit-transform:rotate(360deg)}}@keyframes spin-data-v-642082a0{0%{transform:rotate(0)}100%{transform:rotate(360deg)}}.bulk-action[data-v-642082a0]{width:1rem}div.tbl-responsive[data-v-642082a0]{overflow-x:auto}",
    map: undefined,
    media: undefined
  });
};
/* scoped */


const __vue_scope_id__ = "data-v-642082a0";
/* module identifier */

const __vue_module_identifier__ = undefined;
/* functional template */

const __vue_is_functional_template__ = false;
/* style inject SSR */

/* style inject shadow dom */

const __vue_component__ = /*#__PURE__*/normalizeComponent({
  render: __vue_render__,
  staticRenderFns: __vue_staticRenderFns__
}, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, createInjector, undefined, undefined);

// Import vue component
// IIFE injects install function into component, allowing component
// to be registered via Vue.use() as well as Vue.component(),

var entry_esm = /*#__PURE__*/(() => {
  // Get component instance
  const installable = __vue_component__; // Attach install function executed by Vue.use()

  installable.install = Vue => {
    Vue.component('VueMorphTable', installable);
  };

  return installable;
})(); // It's possible to expose named exports when writing components that can
// also be used as directives, etc. - eg. import { RollupDemoDirective } from 'rollup-demo';
// export const RollupDemoDirective = directive;

export default entry_esm;
