'use strict';function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script = {
  name: "vue-morph-table",
  props: {
    alias: String,
    items: Array,
    fields: Array,
    actions: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    addTableClasses: [String, Array, Object],
    responsive: {
      type: Boolean,
      default: true
    },
    size: String,
    dark: Boolean,
    pagination: Boolean,
    striped: Boolean,
    fixed: Boolean,
    hover: Boolean,
    border: Boolean,
    outlined: Boolean,
    bulkAction: Boolean,
    header: {
      type: Boolean,
      default: true
    },
    sorter: [Object, Boolean],
    sorterValue: {
      type: Object,
      default: function _default() {
        return {};
      }
    },
    numOfRows: Array,
    itemsLength: Number,
    loading: Boolean
  },
  data: function data() {
    return {
      show: false,
      overlayStyle: {
        width: "0%",
        opacity: 0
      },
      sorterState: {
        column: null,
        asc: true
      },
      checkAll: false,
      lastFields: -1,
      currentPage: 1,
      noRows: 10
    };
  },
  computed: {
    totalPage: function totalPage() {
      return Math.ceil(this.$props.itemsLength / this.noRows);
    },
    allFields: {
      get: function get() {
        var _this = this;

        var showFieldsLength = 0;
        this.$props.fields.forEach(function (f) {
          if (_this.alias) localStorage.setItem("".concat(f.key, ".").concat(_this.alias, ".morph"), f.check);
          if (f.check) showFieldsLength++;
        });

        if (showFieldsLength === this.$props.fields.length) {
          this.checkAll = true;
        } else {
          this.checkAll = false;
        }

        return this.$props.fields;
      },
      set: function set(newVal) {
        this.$emit("update:fields", newVal);
      }
    },
    filterFields: function filterFields() {
      var ret = [];
      var idx = -1;
      this.allFields.forEach(function (f, index) {
        if (f.check) {
          ret.push(f);
          idx = index;
        }
      });
      this.lastFields = ret.length === 1 ? idx : -1;
      return ret !== [] ? ret : null;
    },
    tableClasses: function tableClasses() {
      return ["table", this.addTableClasses, {
        "table-striped": this.striped,
        "table-hover": this.hover,
        "table-bordered": this.border,
        border: this.outlined
      }];
    },
    itemsDataColumns: function itemsDataColumns() {
      var _this2 = this;

      return this.rawColumnNames.filter(function (name) {
        return _this2.generatedColumnNames.includes(name);
      });
    },
    generatedColumnNames: function generatedColumnNames() {
      return Object.keys(this.items[0] || {}).filter(function (el) {
        return el.charAt(0) !== "_";
      });
    },
    columnNames: function columnNames() {
      var _this3 = this;

      if (this.filterFields) {
        return this.filterFields.map(function (f) {
          return f.label !== undefined ? f.label : _this3.pretifyName(f.key || f);
        });
      }

      return this.rawColumnNames.map(function (el) {
        return _this3.pretifyName(el);
      });
    },
    rawColumnNames: function rawColumnNames() {
      if (this.filterFields) {
        return this.filterFields.map(function (el) {
          return el.key || el;
        });
      }

      return this.generatedColumnNames;
    },
    sidebarWidth: function sidebarWidth() {
      var value = this.show ? "250px" : 0;
      return {
        width: value
      };
    },
    checkAllBulk: {
      get: function get() {
        var cnt = 0;
        this.items.forEach(function (i) {
          if (i.check_bulk === true) cnt++;
        });

        if (cnt === this.items.length) {
          return true;
        }
      },
      set: function set(newVal) {
        if (newVal === true) {
          var ret = _toConsumableArray(this.items);

          ret.map(function (i) {
            i.check_bulk = true;
          });
          this.$emit("update:items", ret);
        }
      }
    }
  },
  watch: {
    currentPage: function currentPage(val) {
      if (val < 1) val = 1;else if (val > this.totalPage) val = totalPage;
      this.$emit("changeCurrentPage", val);
    },
    sorterValue: {
      immediate: true,
      handler: function handler(val) {
        var asc = val.asc !== false;
        this.sorterState = Object.assign({}, {
          asc: asc,
          column: val.column
        });
      }
    },
    checkAll: function checkAll(val) {
      if (val === true) {
        this.allFields.forEach(function (f) {
          f.check = true;
        });
      }
    }
  },
  methods: {
    range: function range(currentPage) {
      if (currentPage === 1 || currentPage === 2 || currentPage === 3) {
        if (this.totalPage < 5) return this.totalPage;
        return 5;
      } else if (currentPage === this.totalPage || currentPage === this.totalPage - 1 || currentPage === this.totalPage - 2) {
        if (this.totalPage < 5) return this.totalPage;
        return [this.totalPage - 4, this.totalPage - 3, this.totalPage - 2, this.totalPage - 1, this.totalPage];
      } else {
        return [currentPage - 2, currentPage - 1, currentPage, currentPage + 1, currentPage + 2];
      }
    },
    changePage: function changePage(page) {
      if (page > this.totalPage) page = this.totalPage;else if (page < 1) page = 1;
      this.currentPage = page;
    },
    changeSort: function changeSort(column, index) {
      if (!this.isSortable(index)) {
        return;
      }

      var state = this.sorterState;
      var columnRepeated = state.column === column;
      state.column = column;
      state.asc = !(columnRepeated && state.asc);
      this.$emit("update:sorter-value", this.sorterState);
      this.$emit("sort", this.sorterState);
    },
    getIconState: function getIconState(index) {
      var direction = this.sorterState.asc ? "asc" : "desc";
      return this.rawColumnNames[index] === this.sorterState.column ? direction : 0;
    },
    iconClasses: function iconClasses(index) {
      var state = this.getIconState(index);
      return ["arrow", {
        transparent: !state,
        "rotate-icon": state === "desc"
      }];
    },
    pretifyName: function pretifyName(name) {
      return name.replace(/[-_.]/g, " ").replace(/ +/g, " ").replace(/([a-z0-9])([A-Z])/g, "$1 $2").split(" ").map(function (word) {
        return word.charAt(0).toUpperCase() + word.slice(1);
      }).join(" ");
    },
    isSortable: function isSortable(index) {
      return this.sorter && (!this.fields || this.fields[index].sorter !== false) && this.itemsDataColumns.includes(this.rawColumnNames[index]);
    },
    openSidebar: function openSidebar() {
      this.show = true;
      this.overlayStyle.width = "100%";
      this.overlayStyle.opacity = 0.8;
    },
    closeSidebar: function closeSidebar() {
      this.show = false;
      this.overlayStyle.width = "0%";
      this.overlayStyle.opacity = 0;
    },
    changeCheck: function changeCheck(index) {
      this.$emit("update:fields", [].concat(_toConsumableArray(this.fields.slice(0, index)), [_objectSpread2(_objectSpread2({}, this.fields[index]), {}, {
        check: !this.fields[index].check
      })], _toConsumableArray(this.fields.slice(index + 1))));
    },
    changeCheckBulk: function changeCheckBulk(index) {
      this.$emit("update:items", [].concat(_toConsumableArray(this.items.slice(0, index)), [_objectSpread2(_objectSpread2({}, this.items[index]), {}, {
        check_bulk: !this.items[index].check_bulk
      })], _toConsumableArray(this.items.slice(index + 1))));
    },
    changeCheckAll: function changeCheckAll() {
      this.checkAll = true;
    },
    changeCheckAllBulk: function changeCheckAllBulk() {
      this.checkAllBulk = true;
    },
    changeNumOfRows: function changeNumOfRows(e) {
      this.noRows = e.target.value;
      this.$emit("changeNumOfRows", e.target.value);
    },
    clickRow: function clickRow(data) {
      this.$emit("clickRow", data);
    }
  }
};function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}function createInjectorSSR(context) {
    if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
        context = __VUE_SSR_CONTEXT__;
    }
    if (!context)
        return () => { };
    if (!('styles' in context)) {
        context._styles = context._styles || {};
        Object.defineProperty(context, 'styles', {
            enumerable: true,
            get: () => context._renderStyles(context._styles)
        });
        context._renderStyles = context._renderStyles || renderStyles;
    }
    return (id, style) => addStyle(id, style, context);
}
function addStyle(id, css, context) {
    const group = css.media || 'default' ;
    const style = context._styles[group] || (context._styles[group] = { ids: [], css: '' });
    if (!style.ids.includes(id)) {
        style.media = css.media;
        style.ids.push(id);
        let code = css.source;
        style.css += code + '\n';
    }
}
function renderStyles(styles) {
    let css = '';
    for (const key in styles) {
        const style = styles[key];
        css +=
            '<style data-vue-ssr-id="' +
                Array.from(style.ids).join(' ') +
                '"' +
                (style.media ? ' media="' + style.media + '"' : '') +
                '>' +
                style.css +
                '</style>';
    }
    return css;
}/* script */
var __vue_script__ = script;
/* template */

var __vue_render__ = function __vue_render__() {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "wrapper"
  }, [_vm._ssrNode("<div class=\"overlay\"" + _vm._ssrStyle(null, _vm.overlayStyle, null) + " data-v-642082a0></div> <div class=\"sidebar\"" + _vm._ssrStyle(null, _vm.sidebarWidth, null) + " data-v-642082a0><a href=\"javascript:void(0)\" class=\"close-btn\" data-v-642082a0>×</a> <div class=\"content\" data-v-642082a0><div class=\"form-check-default box-checkbox\" data-v-642082a0><input type=\"checkbox\" value=\"all\" id=\"flexCheckDefault\"" + _vm._ssrAttr("disabled", _vm.checkAll) + _vm._ssrAttr("checked", _vm.checkAll) + " class=\"form-checkbox-input\" data-v-642082a0> <label for=\"flexCheckDefault\" class=\"form-checkbox-label\" data-v-642082a0> All</label></div> " + _vm._ssrList(_vm.allFields, function (field, index) {
    return "<div class=\"form-check-default box-checkbox\" data-v-642082a0><input type=\"checkbox\"" + _vm._ssrAttr("id", "flexCheckDefault-" + index) + _vm._ssrAttr("disabled", _vm.lastFields === index) + _vm._ssrAttr("value", field.value) + _vm._ssrAttr("checked", field.check) + " class=\"form-checkbox-input\" data-v-642082a0> <label" + _vm._ssrAttr("for", "flexCheckDefault-" + index) + " class=\"form-checkbox-label\" data-v-642082a0>" + _vm._ssrEscape("\n              " + _vm._s(field.label) + "\n            ") + "</label></div>";
  }) + "</div></div> <div class=\"utils\" data-v-642082a0><div class=\"separator\" data-v-642082a0></div> " + (_vm.numOfRows ? "<div class=\"select-num-of-rows\" data-v-642082a0><label for=\"num-of-rows\" data-v-642082a0>Number of rows:</label> <select name=\"num-of-rows\" id=\"num-of-rows\" data-v-642082a0>" + _vm._ssrList(_vm.numOfRows, function (num) {
    return "<option" + _vm._ssrAttr("value", num) + " data-v-642082a0>" + _vm._ssrEscape("\n            " + _vm._s(num) + "\n          ") + "</option>";
  }) + "</select></div>" : "<!---->") + " <button class=\"btn\" data-v-642082a0><svg height=\"10pt\" viewBox=\"0 -53 384 384\" width=\"10pt\" xmlns=\"http://www.w3.org/2000/svg\" data-v-642082a0><path d=\"m368 154.667969h-352c-8.832031 0-16-7.167969-16-16s7.167969-16 16-16h352c8.832031 0 16 7.167969 16 16s-7.167969 16-16 16zm0 0\" data-v-642082a0></path> <path d=\"m368 32h-352c-8.832031 0-16-7.167969-16-16s7.167969-16 16-16h352c8.832031 0 16 7.167969 16 16s-7.167969 16-16 16zm0 0\" data-v-642082a0></path> <path d=\"m368 277.332031h-352c-8.832031 0-16-7.167969-16-16s7.167969-16 16-16h352c8.832031 0 16 7.167969 16 16s-7.167969 16-16 16zm0 0\" data-v-642082a0></path></svg></button></div> "), _vm.loading ? _vm._t("loading", [_c('div', {
    staticClass: "loading"
  }, [_c('div', {
    staticClass: "loader"
  })])]) : _vm._e(), _vm._ssrNode(" "), _vm._ssrNode("<div" + _vm._ssrClass(null, "position-relative " + (_vm.responsive ? 'tbl-responsive' : '')) + " data-v-642082a0>", "</div>", [!_vm.loading ? _vm._ssrNode("<table" + _vm._ssrClass(null, _vm.tableClasses) + " data-v-642082a0>", "</table>", [_vm._ssrNode("<thead data-v-642082a0>", "</thead>", [_vm.header ? _vm._ssrNode("<tr data-v-642082a0>", "</tr>", [_vm._ssrNode((_vm.bulkAction ? "<th class=\"bulk-action\" data-v-642082a0><input type=\"checkbox\" name=\"check-all-bulk-actions\" id=\"check-all-bulk-actions\"" + _vm._ssrAttr("disabled", _vm.checkAllBulk) + _vm._ssrAttr("checked", _vm.checkAllBulk) + " data-v-642082a0></th>" : "<!---->") + " "), _vm._l(_vm.columnNames, function (columnName, index) {
    return [_vm._ssrNode("<th data-v-642082a0>", "</th>", [_vm._t(_vm.rawColumnNames[index] + "-header", [_c('span', [_vm._v(_vm._s(columnName))])]), _vm._ssrNode(" "), _vm.isSortable(index) ? _vm._t("sorting-icon", [_c('div', {
      class: _vm.iconClasses(index)
    }, [_c('svg', {
      staticStyle: {
        "enable-background": "new 0 0 512 512"
      },
      attrs: {
        "width": "1rem",
        "version": "1.1",
        "id": "Capa_1",
        "xmlns": "http://www.w3.org/2000/svg",
        "xmlns:xlink": "http://www.w3.org/1999/xlink",
        "x": "0px",
        "y": "0px",
        "viewBox": "0 0 512 512",
        "xml:space": "preserve"
      }
    }, [_c('path', {
      staticStyle: {
        "fill": "#4caf50"
      },
      attrs: {
        "d": "M263.432,3.136c-4.16-4.171-10.914-4.179-15.085-0.019c-0.006,0.006-0.013,0.013-0.019,0.019\n\tl-192,192c-4.093,4.237-3.975,10.99,0.262,15.083c4.134,3.992,10.687,3.992,14.82,0L245.213,36.416v464.917\n\tc0,5.891,4.776,10.667,10.667,10.667c5.891,0,10.667-4.776,10.667-10.667V36.416l173.781,173.781\n\tc4.093,4.237,10.845,4.355,15.083,0.262c4.237-4.093,4.354-10.845,0.262-15.083c-0.086-0.089-0.173-0.176-0.262-0.262L263.432,3.136\n\tz"
      }
    }), _vm._v(" "), _c('path', {
      attrs: {
        "d": "M447.88,213.333c-2.831,0.005-5.548-1.115-7.552-3.115L255.88,25.749L71.432,210.219c-4.237,4.093-10.99,3.975-15.083-0.262\n\tc-3.992-4.134-3.992-10.687,0-14.82l192-192c4.165-4.164,10.917-4.164,15.083,0l192,192c4.159,4.172,4.149,10.926-0.024,15.085\n\tC453.409,212.214,450.702,213.333,447.88,213.333z"
      }
    }), _vm._v(" "), _c('path', {
      attrs: {
        "d": "M255.88,512c-5.891,0-10.667-4.776-10.667-10.667V10.667C245.213,4.776,249.989,0,255.88,0\n\tc5.891,0,10.667,4.776,10.667,10.667v490.667C266.546,507.224,261.771,512,255.88,512z"
      }
    }), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g'), _vm._v(" "), _c('g')])])], {
      "state": _vm.getIconState(index)
    }) : _vm._e()], 2)];
  }), _vm._ssrNode(" "), _vm._l(_vm.actions, function (action, index) {
    return [_vm._ssrNode("<th data-v-642082a0>", "</th>", [_vm._t(action['key'] + "-header")], 2)];
  })], 2) : _vm._e()]), _vm._ssrNode(" "), _vm._ssrNode("<tbody data-v-642082a0>", "</tbody>", [_vm._l(_vm.items, function (item, itemIndex) {
    return [_vm._ssrNode("<tr data-v-642082a0>", "</tr>", [_vm._ssrNode((_vm.bulkAction ? "<td class=\"bulk-action\" data-v-642082a0><input type=\"checkbox\"" + _vm._ssrAttr("name", "check-" + item.key + "-bulk-action") + _vm._ssrAttr("id", "check-" + item.key + "-bulk-action") + _vm._ssrAttr("checked", item.check_bulk) + " data-v-642082a0></td>" : "<!---->") + " "), _vm._l(_vm.rawColumnNames, function (colName, colNameIndex) {
      return [_vm.$scopedSlots[colName] ? _vm._t(colName, null, {
        "item": item,
        "index": itemIndex
      }) : _c('td', {
        key: colNameIndex
      }, [_vm._v(_vm._s(String(item[colName])))])];
    }), _vm._ssrNode(" "), _vm._l(_vm.actions, function (actionInRow, indexActionInRow) {
      return [_vm.$scopedSlots[actionInRow['key']] ? _vm._t(actionInRow['key'], null, {
        "item": item,
        "index": itemIndex
      }) : _c('td', {
        key: "action_" + indexActionInRow
      }, [_vm._v("\n                  " + _vm._s(actionInRow["name"]) + "\n                ")])];
    })], 2)];
  })], 2)], 2) : _vm._e(), _vm._ssrNode(" " + (!_vm.loading && _vm.pagination && _vm.totalPage !== 1 ? "<div class=\"table-footer\" data-v-642082a0><div class=\"separator\" data-v-642082a0></div> <div class=\"pagination pagination--position\" data-v-642082a0><a href=\"#first\" data-v-642082a0>«</a> <a href=\"#previous\" data-v-642082a0>‹</a> " + _vm._ssrList(_vm.range(_vm.currentPage), function (page) {
    return "<a href=\"javascript:void(0)\"" + _vm._ssrClass(null, {
      'page-active': page === _vm.currentPage
    }) + " data-v-642082a0>" + _vm._ssrEscape(_vm._s(page)) + "</a>";
  }) + " <a href=\"#next\" data-v-642082a0>›</a> <a href=\"#last\" data-v-642082a0>»</a></div> <div class=\"separator\" data-v-642082a0></div></div>" : "<!---->"))], 2)], 2);
};

var __vue_staticRenderFns__ = [];
/* style */

var __vue_inject_styles__ = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-642082a0_0", {
    source: ".separator[data-v-642082a0]{flex:1}.table-footer[data-v-642082a0]{display:flex;align-items:center;justify-content:center}.table-footer .pagination--position[data-v-642082a0]{margin:1.5rem auto 1.5rem 0}.table-footer .pagination a[data-v-642082a0]{color:#000;float:left;padding:8px 16px;text-decoration:none;transition:background-color .3s}.table-footer .pagination a.page-active[data-v-642082a0]{background-color:#2b3856;color:#fff;border-radius:5px}.rotate-icon[data-v-642082a0]{transform:rotate(180deg);top:-.3rem}div.arrow[data-v-642082a0]{display:inline-block;position:relative;margin-left:.1rem;vertical-align:middle;font-size:27px}div.arrow img.sort-icon[data-v-642082a0]{padding:0;width:1rem}.position-relative[data-v-642082a0]{position:relative}div.wrapper[data-v-642082a0]{font-family:Arial,Helvetica,sans-serif}div.wrapper div.overlay[data-v-642082a0]{position:fixed;height:100vh;z-index:3000;left:0;top:0;background-color:#111}div.wrapper div.sidebar[data-v-642082a0]{position:fixed;height:100%;z-index:3000;top:0;right:0;background-color:#fff;overflow-x:hidden;transition:.5s;padding-top:60px}div.wrapper div.sidebar a[data-v-642082a0]{padding:8px 8px 8px 32px;text-decoration:none;font-size:25px;color:#616161;display:block;transition:.3s}div.wrapper div.sidebar a[data-v-642082a0]:hover{color:#a1a1a1;cursor:pointer}div.wrapper div.sidebar .close-btn[data-v-642082a0]{position:absolute;top:0;right:10px;font-size:24px;margin-left:10px}div.wrapper div.sidebar .content[data-v-642082a0]{margin:0 0 0 2rem}.table[data-v-642082a0]{border-collapse:collapse;width:100%}.table td[data-v-642082a0],.table th[data-v-642082a0]{border-top:1px solid #ddd;border-bottom:1px solid #ddd;padding:8px;white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.table.table-bordered td[data-v-642082a0],.table.table-bordered th[data-v-642082a0]{border:1px solid #ddd;padding:8px}.table th[data-v-642082a0]{padding-top:12px;padding-bottom:12px;text-align:left;background-color:#fff}.table.table-striped tr[data-v-642082a0]:nth-child(odd){background-color:#f2f2f2}.table.table-hover tr[data-v-642082a0]:hover{background-color:#ddd}.btn[data-v-642082a0]{border:none;padding:15px 32px;text-align:center;text-decoration:none;display:inline-block;font-size:16px;background-color:#fff}.utils[data-v-642082a0]{display:flex;align-items:center}.utils .select-num-of-rows[data-v-642082a0]{margin-right:10px}.utils .select-num-of-rows label[data-v-642082a0]{margin-right:10px}.utils .select-num-of-rows select#num-of-rows[data-v-642082a0]{padding:.5rem 1rem;background-color:#fff;border:1px solid #ddd;color:#333;border-radius:5px}.utils .select-num-of-rows select#num-of-rows[data-v-642082a0]:hover{border-color:#999;background-color:#eee}.utils .select-num-of-rows select#num-of-rows option[data-v-642082a0]{padding:.5rem 1rem;background-color:#fff}.loading[data-v-642082a0]{position:absolute;display:flex;align-items:center;justify-content:center;height:25rem;width:100%;background-color:#eee}.loading .loader[data-v-642082a0]{border-radius:50%;border:8px solid #eee;border-top:8px solid #3498db;border-bottom:8px solid #3498db;width:60px;height:60px;-webkit-animation:spin-data-v-642082a0 2s linear infinite;animation:spin-data-v-642082a0 2s linear infinite}@-webkit-keyframes spin-data-v-642082a0{0%{-webkit-transform:rotate(0)}100%{-webkit-transform:rotate(360deg)}}@keyframes spin-data-v-642082a0{0%{transform:rotate(0)}100%{transform:rotate(360deg)}}.bulk-action[data-v-642082a0]{width:1rem}div.tbl-responsive[data-v-642082a0]{overflow-x:auto}",
    map: undefined,
    media: undefined
  });
};
/* scoped */


var __vue_scope_id__ = "data-v-642082a0";
/* module identifier */

var __vue_module_identifier__ = "data-v-642082a0";
/* functional template */

var __vue_is_functional_template__ = false;
/* style inject shadow dom */

var __vue_component__ = /*#__PURE__*/normalizeComponent({
  render: __vue_render__,
  staticRenderFns: __vue_staticRenderFns__
}, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, undefined, createInjectorSSR, undefined);// Import vue component
// IIFE injects install function into component, allowing component
// to be registered via Vue.use() as well as Vue.component(),

var component = /*#__PURE__*/(function () {
  // Get component instance
  var installable = __vue_component__; // Attach install function executed by Vue.use()

  installable.install = function (Vue) {
    Vue.component('VueMorphTable', installable);
  };

  return installable;
})(); // It's possible to expose named exports when writing components that can
// also be used as directives, etc. - eg. import { RollupDemoDirective } from 'rollup-demo';
// export const RollupDemoDirective = directive;
var namedExports=/*#__PURE__*/Object.freeze({__proto__:null,'default': component});// only expose one global var, with named exports exposed as properties of
// that global var (eg. plugin.namedExport)

Object.entries(namedExports).forEach(function (_ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      exportName = _ref2[0],
      exported = _ref2[1];

  if (exportName !== 'default') component[exportName] = exported;
});module.exports=component;